require "util"
require "config"

local time_left_to_use_portal = 0

script.on_event(defines.events.on_tick, function(event)
  if time_left_to_use_portal > 0 then
    time_left_to_use_portal = time_left_to_use_portal - 1
  end
end)

script.on_event(defines.events.on_built_entity, function(event) 
  if event.created_entity ~= nil and event.created_entity.name == "portal" then
    local player = game.players[event.player_index]
    local destination = event.created_entity.position
    event.created_entity.destroy()
    TryActivatePortal(player, destination)
    player.insert({name = "portal", count = 1})
  end
end)

script.on_event(defines.events.on_put_item, function(event)
	local player = game.players[event.player_index]
  local destination = event.position
  TryActivatePortal(player, destination)
end)

function TryActivatePortal(player, destination_position)
	if IsHolding({name="portal", count=1}, player) then
    if time_left_to_use_portal > 0 then
      if PERIOD_BETWEEN_USAGES - time_left_to_use_portal > 5 then
        player.print({"too-frequent-use", PERIOD_BETWEEN_USAGES / 60})
      end
      return
    else
      if IGNORE_COLLISIONS or player.surface.can_place_entity({name = "medium-biter", position = destination_position}) then
        player.teleport(destination_position, player.surface)
        time_left_to_use_portal = PERIOD_BETWEEN_USAGES
      else
        player.print({"invalid-destination"})
      end
    end
	end
end

function IsHolding(stack, player) -- thanks to supercheese (Orbital Ion Cannon author)
	local holding = player.cursor_stack
	if holding and holding.valid_for_read and (holding.name == stack.name) and (holding.count >= stack.count) then
		return true
	end
	return false
end